#ifndef GeneralHeader
#define GeneralHeader

using namespace std;


#include <ctype.h>
#include <cstring>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <png.h>
#include "dSFMT.h"

//#define RESTART


#define TESTPLT

//#define PLTDEPZONATION

//#define PLASMODESMATACLOSED
#define PLASMODESMATAOPEN
//#define PLTLEAKAGETOMAINROOT

//#define SMBMUTANT

#define ASYMMETRIC
//#define NORMALSHOOTROOTCONNECTION
//#define SHOOTROOTCUT
#define LOWAUXIN_FROMSHOOT

//ifdef for CellPaper

//(Fig1C)
//#define LOWAUXINPROD_LRC
//#define LOW_AUXINFROMSHOOT 
//#define LOWAUXINPROD_QC

// Fig 1D
//#define VASCPIN_ONLY
//#define VASCPIN_PIN2UP
//#define VASCPIN_PIN2LOW

//Fig 1E
//#define AUX1Vasc_High
//#define AUX1Epi_High


//#define SPECIALTZBOUNDARY
//#define VASCDIFFERENT //Cell larger
//#define VASCDIFFONLYRATE //Cell cycle faster

//#define GROWTHDIVSIMANDSIZECOMP
//#define COMPENSATESIZEDIFFERENCESEZ
//#define SYNCEDEZENTRY


//Auxin transport is non-saturated in default

//#define AUXINAPPLICATION
#define AUX1INEPI
//#define AUX1LRCextra


//#define LAX3PREPATTERN
const double SatLax3 = 100;

//#define TROPIC
#ifdef TROPIC
//#define STATICGRAVITROPISM
//#define DYNAMICGRAVITROPISM
//#define ENHANCEDGRAVITROPISM
//#define HALOTROPIC
//#define ENHANCEDHALOTROPISM
#endif

//#define AUXINREGULATESPIN
//#define PINREGULATED
#define AUX1REGULATED
//#define YUC3GH33REGULATED

#define POLAR
//#define APOLAR
//#define POLARMERISTEM
#define APOLARMERISTEM
//#define GRAVITROPIC


 //#define CYTOKININ


//general parameters
extern char dirname[2000];

extern double phase;


extern int idlist[4000];
extern int idcounter;
extern int memidv;
extern int memidp;

extern int  counter_priming;
extern int  sum_period;
extern int  max_period;
extern int  min_period;
extern int  previous_time_priming;
extern int  previous_period;
extern int  spacing_counter;
extern double  max_spacing;
extern double  min_spacing;
extern int  counter_spacinggroups;
extern double  sum_of_spacing;
extern int  CellProduction_peri;
extern int  time_first_priming;
extern double lastdivt_P; 
extern double lastdivMinJ_P; 
extern double ratioMeanCell_P; 
extern double lastdivt_NP;  
extern double lastdivMinJ_NP; 
extern double ratioMeanCell_NP; 
extern int number_clones_outsync;

const double tstep=0.2;//0.2
const double tmax=100000;//2419200;
const int maxnrsteps=(int)(tmax/tstep);
const int tsave=(int)(200/tstep);
const double xstep=2;//1
const int speedup2=10;
const double tdelay=86400;


//parameters setting up horizontal tissue layout in straight part
const int disttolrc=20;//horizontal buffersize: start rectangle to start lrc
const int sizetoplrc=(int)(8./xstep)+1;//+1 is for wall
const int disttoepi=disttolrc+sizetoplrc;
const int nrepi=1;
const int sizeepi=(int)(18./xstep);//12
const int totsizeepi=nrepi*sizeepi+nrepi;
const int nrcort=1;
const int sizecort=(int)(20./xstep);//14
const int totsizecort=nrcort*sizecort+nrcort;
const int nrendo=1;
const int sizeendo=(int)(12./xstep);//8
const int totsizeendo=nrendo*sizeendo+nrendo;
const int nrperi=1;
const int sizeperi=(int)(8./xstep);//(int)(6./xstep)
const int totsizeperi=nrperi*sizeperi+nrperi;
const int nrvasc=3;//4
const int sizevasc=(int)(6./xstep);//(int)(4./xstep)
const int totsizevasc=nrvasc*sizevasc+nrvasc;
const int n=2*(disttolrc+sizetoplrc+totsizeepi+totsizecort+totsizeendo+totsizeperi+totsizevasc)+2-1;
const int xm=disttolrc+sizetoplrc+totsizeepi+totsizecort+totsizeendo+totsizeperi+totsizevasc;
//cell numbers
const int totcells=4000;                            //maximum totalnr of cells
extern int actcells;
const int zoom=1;               //zoom factor used for display



//parameters setting up vertical tissue layout
//cell sizes
const int HS1=44/xstep;//height first columella cell
const int HS2=30/xstep;//height second columella cell
const int HS3=20/xstep;//height third columella cell
const int HS4=14/xstep;//height fourth columella cell
const int HS5=10/xstep;//height fifth columella cell
const int HCI=8/xstep;//height columella initial
const int HMZ=8/xstep;//!!!!!!!!!!10/xstep;//height meristem cells
const int HEZ=60/xstep;//height elongation zone cells GRADIENT OF DIFFERENT SIZES USED
const int HDZ=100/xstep;//height differentiation zone cells DIFFERENT SIZES USED

//please note that once cells are growing and dividing
//cells will on average be 1.5 the basic size because
//they are growing towards double their size
//so to fit in on average 20 cells we should ask initially 
//for 30 cells that all have the basic size
const int nrcellsstraightMZ=40;
//vertical start positions
const int yzero=8;                              //bottom buffer size, start rectangle to root tip 
const int yQC=yzero+(HS1+HS2+HS3+HS4+HS5+HCI)+6;//bottom position QC: yzero+6 cells columella +6 walls
const int yR=yQC+3*HMZ+3; //yQC+3*HMZ+3; //yQC+5*HMZ+5;    //start radial lines: yQC +5 MZ cells+5 walls
const int yLRCstraight=yR-2*HMZ-2;//yR;//yR+5*HMZ+5;
const int yMZEZ=yLRCstraight+nrcellsstraightMZ*HMZ+nrcellsstraightMZ;//MZ-EZ boundary MZ supposedly 30 cells
const int yLRC1=yLRCstraight+nrcellsstraightMZ*HMZ+nrcellsstraightMZ;//typically equal to yMZEZ
const int yEND=yLRCstraight+75*HMZ+75+15*HEZ+5*HDZ+21;         //15 cells (10 EZ 5 DZ) + 16 walls    
const int m=(int)(yEND+30);                   //size of field in y-dir 





//how to construct a parabola: y=ax^n+b
//we know two points, say (xLRC2,yLRC2) which is the upperleft startpoint 
//and the point (xm,yzero+HS1+1) which is the mini7beco
//translated into (abs(xLRC2-xm),yLRC2) and (0,yzero+HS1+1)
//for x=0 y=b thus b=yzero+HS1+1 is the y value of this minimum point
//the value of a then follows from a=(y-b)/x^n

//parabola lines
//parabola around LRC1
const int x0LRC1=disttolrc;//-2/xstep;
const double bLRC1=yzero;
const int powLRC1=3;
const double aLRC1=(yLRCstraight-bLRC1)/(abs(pow((x0LRC1-xm),powLRC1))); //!
//so for y<yLRC1: y=aLRC1*(x-xm)^2+bLRC1

//parabola around LRC2
const int x0LRC2=x0LRC1+16/xstep+1;//+12/xstep+1;
const int yLRC2=yQC-10/xstep;//+10/xstep;//+6*HMZ+2/xstep;//-4 voor xstep=1
const double bLRC2=bLRC1+HS1+1; 
const int powLRC2=3;
const double aLRC2=(yLRC2-bLRC2)/(abs(pow((x0LRC2-xm),powLRC2)));
//so for y<yLRC2: y=aLRC2*(x-xm)^2+bLRC2

//parabola around LRC3
const int x0LRC3=x0LRC2+16/xstep+1;//x0LRC2+16/xstep+1;
const int yLRC3=yQC-(30/xstep);//yQC-(20/xstep);//+2*HMZ+(2/xstep);//yQC+2*HMZ+(6/xstep);//+3 voor xstep=1
const double bLRC3=bLRC2+HS2+1;
const int powLRC3=3;
const double aLRC3=(yLRC3-bLRC3)/(abs(pow((x0LRC3-xm),powLRC3)));
//so for y<yLRC3: y=aLRC3*(x-xm)^2+bLRC3

//parabola around LRC4
const int x0LRC4=x0LRC3+4/xstep+1;//x0LRC3+14/xstep+1;
const int yLRC4=yQC-(26/xstep);//yQC-(12/xstep);//-(8/xstep);//yQC-(4/xstep);
const double bLRC4=bLRC3+HS3+1;
const int powLRC4=2;
const double aLRC4=(yLRC4-bLRC4)/(abs(pow((x0LRC4-xm),powLRC4)));
//so for y<yLRC4: y=aLRC4*(x-xm)^2+bLRC4


//note that what is called intercept here is the same as the
//x... in the above parabolas: the x coordinate of the left
//upper intersection point of the parabola;
//note that for all parabola the corresponding y value of this
//point should be yLRCstraight, below which the parabolas start
//parabola around epi and underneath S5
const int intercEPI=disttoepi;
const double bEPI=bLRC4+HS4-1;//+1;
const int powEPI=3;
const double aEPI=(yLRCstraight-bEPI)/(abs(pow((intercEPI-xm),powEPI)));
//so for y<yLRC1 y=aEPI*(x-xm)^2+bEPI

//parabola around cortex and underneath QC
const int intercCORT=intercEPI+totsizeepi;
const double bCORT=bEPI+HS5+1;
const int powCORT=3;
const double aCORT=(yLRCstraight-bCORT)/(abs(pow((intercCORT-xm),powCORT)));
//so for y<yLRC1 y=aCORT*(x-xm)^3+bCORT

//parabola around endo and underneath QC (needs to stop early)
const int intercENDO=intercCORT+totsizecort;
const double bENDO=bCORT+0.6*HCI+1;
const int powENDO=4;
const double aENDO=(yLRCstraight-bENDO)/(abs(pow((intercENDO-xm),powENDO)));
//so for y<yLRC1 y=aENDO*(x-xm)^4+bENDO

//parabola around peri and at bottom QC 
const int intercPERI=intercENDO+totsizeendo;
const double bPERI=yQC;
const int powPERI=5;
const double aPERI=(yLRCstraight-bPERI)/(abs(pow((intercPERI-xm),powPERI)));
//so for y<yLRC1 y=aPERI*(x-xm)^4+bPERI

//parabola around vasc and at bottom QC
const int intercVASC=intercPERI+totsizeperi;
const double bVASC=yQC;
const int powVASC=3;//4;
const double aVASC=(yLRCstraight-bVASC)/(abs(pow((intercVASC-xm),powVASC)));
//so for y<yLRC1 y=aVASC*(x-xm)^4+bVASC
 
//radial lines
//all go through point x=xm, y=yR
//equation for lines should be of form y=a*x+b
//so we know alreadu yR=a*xm+b
//so pick desired slope a and find b
const double arad1=0.5;
const double brad1=yR-arad1*xm;
const double arad2=1;//1.2;//1.3;//CHANGED!!!!
const double brad2=yR-arad2*xm;
const double arad3=2.1;//2.3;//2.5;;//CHANGED!!!!
const double brad3=yR-arad3*xm;
const double arad4=5;//6;
const double brad4=yR-arad4*xm;

//auxine parameters
const double DauxC=600;
const double DauxW=40.;
const double eff=1;//0.01;//1.;
const double inAux=0.;
const double dAux=0.00005*1.45;//*10;;
const double pAux=0.0005*3;//
const double pPUMP=0.2;
#ifdef AUX1INEPI
const double inf=2.5;//10;
#else
const double inf=10;
#endif



//to get an idea of timing:
//d=0.0008;//(1/d)=1250s=20.8min=0.35hrs ln2/d=866s=14min=0.24hrs
//d=0.0002;//(1/d)=5000s=83min=1.39hrs ln2/d=3465s=58min=0.96hrs
//d=0.0001;//(1/d)=10000s=166min=2.78hrs ln2/d=6931s=115min=1.93hrs
//d=0.00005;//(1/d)=20000s=333min=5.55hrs ln2/d=13862s=231min=3.85hrs
//d=0.00002;//(1/d)=50000s=833min=13.89hrs ln2/d=34657s=577min=9.62hrs
//d=0.00001;//(1/d)=100000s=1666min=27.78hrs ln2/d=69314s=1155min=19.25hrs

//plt gradient depends on:
//at which auxin level half-saturation of expression 
//decay rate of plt, but this is also constrained 
//by time it takes for plt to become expressed
//maybe slow onset of plt expression should be 
//done using a delay time rather than using low
//production and decay rate, in this case upon
//cell growth expression level can be restored
//however it also means faster decay when cell
//is out of range expression domain, but maybe
//this makes sense: if cells undergo only few
//divisions rest of gradient is through decay
//amount of cellular growth, number of divisions
//spread through plasmodesmata




const int km_pin1 =10;
const int km_pin2 =10;//10
const double offsetpin=0;
const double maxpin=0.01;
const double satpin=40;//20;//40;
const double decaypin=0.0001;
const double pinfac1=1;//0.6;

extern double gauss[10000];
extern double tempcumgauss[100000];
const int Hdiv=2*HMZ;
const int Hdivlrc=4*HMZ;
const int Hmax=175/xstep;//144/xstep;
//note that division takes only place in the straight part of the meristem
//we put in initially 30 cells, as cells will approximately be 1.5 their
//basic size this meanst that during growth on average 20 cells will be
//present
//given that the elongation zone is 7-11 cells and cells transit through it
//in approximately 7 hours, replenishment requires 1-1.5 cell divisions per
//meristematic cell file per hour
//assuming 30-35 actively dividing cells in the meristem this has led to
//estimations of division rates of 0.05-0.029 and hence of division times of
//20-35 hours
//however it seems that in the upper part of the meristem/TZ cells are still
//growing slowly but no longer dividing, meaning that less cells are 
//contributing to division and hence division times are overestimated
//relative to what they really are, if we for example assume that the last
//5 cells do not participate in division we get rates of 0.06-0.033 and hence
//times of 16.7-30 hrs, and numbers go down further if we take into account
//the much slower divisions closer to the SCN/QC
//in our model we assume that in the upper region size of 4 meristem cells
//this is the case, leaving us with 20-4=16 dividing cells
//this is much lower than in reality because the first 10 MZ cells are in the
//curved non dividing part
//as a consequence we need to lower our division times to get realistic 
//growth rates:
//1.5 cells/file/hr -> 1.5cells/16cells/hr=0.09375/hr -> 10.7 hrs
const double avgdivtime=9.1*3600;//10*3600;//11*3600;//8.2*3600;//29520


const double avgdivtimeSC=avgdivtime*4.2;//41*3600;
const double avgdivtimeSC2=avgdivtime*3.5;//28*3600;
const double avgdivtimeSC3=avgdivtime*2.8;//12*3600;
const double avgdivtimeSC4=avgdivtime*1.6;//12*3600;
/*

*/
const double avgelongtime=7*3600;//7.9*3600;//28440
const double varperc=0.15;//0.15;//0.025;//0.10;//0.15;//0.20;

//gene expression parameters
//GG
#ifndef TESTPLT8
const double maxgg=0.005;
const double decaygg=0.00005;
#else
const double maxgg=0.005;//*10;
const double decaygg=0.00005;//*10;
#endif
const double satgg=40;
const double offsetgg=0;
//PLTslow
const double maxplts=0.00175;//0.003;//0.00175;
const double satplts=40;
const double decayplts=0.0000175;//0.00003;//0.0000175;
//PLT
const double maxplt=0.02;
const double satplt=40;
const double decayplt=0.0002;//(1/d)=5000s=83min=1.39hrs ln2/d=3465s=58min=0.96hrs
const double offsetplt=0;
//Pin

//Yuc3
const double maxyuc3=0.01;
const double satyuc3=40;//20;//40;
const double decayyuc3=0.0001;
const double yuc3fac=0.7;//0.9;//0.75;
//Gh33
const double maxgh33=0.01;
const double satgh33=40;//20;//40;
const double decaygh33=0.0001;
const double gh33fac=0.7;//0.9;//0.75;
//Aux1
const double maxaux1=0.01;//0.04;//0.01
const double sataux1=100;
const double decayaux1=0.0001;
const double km_aux1 = 50;//200;
#ifdef AUX1INEPI
const double aux1fac=0.07;//0.05;//0.1;//0.2;//0.07;
#else
const double aux1fac=0;
#endif
const double offsetaux1=0;

#ifdef LAX3PREPATTERN
const double maxlax3=0.08;//0.01
const double km_lax3=125;
const double decaylax3=0.0001;
#endif
//Differentiation
const double decaydiffrate=0.00001*10.5;// -ln(0.15)/diffrate = (h)
const double diffrate=0.001*10.5;//

//grid based properties
extern double **Caux1;
extern double **Caux2;
extern double **Cauxint;
#ifdef SATURATION  
extern double **inf_sat;
extern double **eff_sat;
extern double **pPUMP_sat;
extern double **aux1fac_sat;
extern double **lax3fac_sat;
#endif
extern int **Tc;
extern int **Tmt;
extern int **Tct;
extern double **PinPrePat;
extern double **Cpin1M;
extern double **Aux1PrePat;
extern double **Aux1M;
extern double **Lax3PrePat;
extern double **Lax3M;
extern double **Pltsgrid;
extern double **Pltsgrid2;
extern double **dummypict;
extern double *BaseMeanCell;
extern double *TempAuxin;
extern double *IncrAuxin;
//cells on grid
extern int **Cell;
//cell based properties
extern int *CellMinI;
extern int *CellMaxI;
extern int *CellMinJ;
extern int *CellMaxJ;
extern int *CellWidth;
extern int *CellHeight;
extern int *CellSizes;
extern int *TrackClones;
extern int *OldTrackClones;
extern double *InvCellSizes;
extern double *MeanCells;
extern double *OldMeanCells;
extern double *BaselineAuxine;
extern double *DiffAuxine;
extern double *TimeOfAuxineIncrease;
extern int *LastDiv_t;
extern int *OldLastDiv_t;
extern int *LastDiv_MinJ;
extern int *OldLastDiv_MinJ;
extern int *goodtogotoEZ;
extern int *OldgoodtogotoEZ;

//cell based gene expression
extern double *ARF;
extern double *AA;
extern double *BB;
extern double *CC;
extern double *DD;
extern double *Plt;
extern double *Pltexpr;
extern double *Plts;
extern double *Pltsexpr;
extern double *PP;
extern double *Pin;
extern double *Aux1;
extern double *Lax3;
extern double *Yuc3;
extern double *Gh33;
extern double *OldARF;
extern double *OldAA;
extern double *OldBB;
extern double *OldCC;
extern double *OldDD;
extern double *OldPlt;
extern double *OldPltexpr;
extern double *OldPlts;
extern double *OldPltsexpr;
extern double *OldPP;
extern double *OldPin;
extern double *OldAux1;
extern double *OldLax3;
extern double *OldYuc3;
extern double *OldGh33;
//cell based growth properties
extern int **OldSit;
extern int *MapCellNrs;
extern int *JustChecked;
extern int *TimePrevGrowth;
extern int *CellZonationState;
extern int *CellDivNr;
extern int *CellTimeLastDiv;
extern int *ProductionCounter;
extern int *OldProductionCounter;
extern double *Diff;
extern double *Rdiv;
extern double *Relong;		
extern double *Rgrow;
extern double *Rgrowavg;
extern int *OldJustChecked;
extern int *OldTimePrevGrowth;
extern int *OldCellZonationState;
extern int *OldCellDivNr;
extern int *OldCellTimeLastDiv;
extern int *CellsInOZ;
extern int *OldCellsInOZ;
extern double *OldDiff;
extern double *OldRdiv;
extern double *OldRelong;
extern double *OldRgrow;
extern double *OldRgrowavg;
extern double *RandNr;

//extern int *Oscilationzone;
//auxin dynamics
extern double *a;
extern double *b;
extern double *c;
extern double *rhs;
extern double *res;
extern double **paux;
extern double **daux;
extern double ***Inf;
extern double ***Eff;
extern double ***DiffAuxC;
//graphics
extern unsigned char *RGBdata;




extern dsfmt_t dsfmt;
inline double uniform() { return dsfmt_genrand_close_open(&dsfmt); }



//Main.cc
void MakeArrays();
void FreeArrays();

//InitPlant.cc
void InitPlant();
void WritePlantToFile(int time);
void InitPlantFromFile(int start);
void SetUpTissueLayout();
void NumberCells();
void FindCellCorners();
void FindCellSizes();
void SetUpMembraneTypes();
void SetUpPrePattern();
void InitConditions();

//Graphics.cc
double min(double a, double b);
double max(double a, double b);
void MakeGraphics(int t);
void MakePNGFile(int t,int flag);

//Plotting.cc
void ExtraMeasurements(int t);
void SaveTotAuxin(int t);
void SaveTemp(int t,int II,int JJ);
void SaveGradCellularRes(int t);
void SaveEpidermalGrad(int time);
void SaveGradGridRes(int time);
void SaveLeftRightDiff(int t);
void TrackWallsSpaceTime(int t);
void PBS_priming(int start, int t);
void CloneSize(int time);

//Growth.cc
void Growth(int time);
void GrowCell(int time,int q,int growthtype);
void DivideCell(int time,int q);
void Division(int time);
void CullOverflowCells(int time);
void CullLateralRootcap(int time);
void StoreOldSituation(int oldactcells);
void MapOldToNewSituation(int oldactcells);
void TrackCells(int time);


//Update.cc
void UpdateAuxin();
void UpdateGeneExpression(int time);
void UpdateMembraneProteinsAndFluxes(int time);

//VisualiseFlux.cc
void StoreAndCompare(int time, int starttime);
void AuxinIncrease(int time); 

#endif
