int nrrow;
int Map[i][j];
int maxnrrows=100;
int nrcellsincurve;

void NewGrowth()
{
  int i,j,q;
  int nrrow;
  double Pltavg;
  double Pltavg[maxnrrows];
  double Rgrow[maxnrrows];

  static int first_time=0;

  if(first_time==0)
    {
      //determine nr of cell rows in tissue from straightish part onward
      //just go to middle of tissue and find out how many cells there are
      //in the vertical direction
      j=yR;
      i=(n/2)-1;
      q=Cell[i][j];
      nrrow=0;
      for(j=yR;j<j<m;j++)
	{
	  while(Cell[i][j]==q)
	    j++;
	  q=Cell[i][j];
	  nrrow++;
	  if(q==-1)
	    j=10*m;//to break
	}
      nrrow--;

      //determine how to map point i,j to a point with j+1 if during growth
      //you have to shift it 1 position upward
      //init to -1 as a check
      for(i=0;i<n;i++)
	for(j=0;j<m;j++) 
	  Map[i][j]=-1;
      
      //in straight part i coordinate stays the same, but you have to go all
      //the way up for future growth,
      for(j=yLRC1;j<m;j++)
	for(i=0;i<n;i++)
	  Map[i][j]=i;

      //in non-straight part do shifts for walls and membranes and cytoplasm
      //to corresponding wall, membrane and cytoplasm point
      //be aware that no shifting is done in middle of cytoplasm
      for(j=yR;j<yLRC1;j++)
	for(i=0;i<n;i++)
	  {
	    if(i<n/2)
	      {
		if(Tc[i][j]!=-3)
		  {
		    if(Tc[i][j+1]!=Tc[i][j])//not same type just above
		      {
			if(Tc[i-1][j+1]==Tc[i][j])//one to left okay
			  Map[i][j]=i-1;
			else if(Tc[i-2][j+1]==Tc[i][j])//two to left okay
			  Map[i][j]=i-2;
			else
			  printf("can not be mapped\n");
		      }
		  }
	      }
	    else
	      {
		if(Tc[i][j]!=-3)
		  {
		    if(Tc[i][j+1]!=Tc[i][j])//not same type just above
		      {
			if(Tc[i+1][j+1]==Tc[i][j])//one to right okay
			  Map[i][j]=i+1;
			else if(Tc[i+2][j+1]==Tc[i][j])//two to right okay
			  Map[i][j]=i+2;
			else
			  printf("can not be mapped\n");
		      }
		  }
	      }
	  }

      first_time=1;
    }



  //average PLTs
  for(row=0;row<nrrow;row++)
    {
      q=row*14+nrcellsincurve;
      Pltavg=0;
      for(i=0;i<14;i++)
	Pltavg+=Plt[q+i];
      Pltavg/=14;
      Pltavg[row]=Pltavg;
    }

  //determine growth rate based on avg PLTs
  for(row=0;row<nrrow;row++)
    {
      if(Pltavg[row]>=40 )//SCN
	Rgrow[row]=0.0000001;
      else if(Pltavg[row]>15)//MZ
	Rgrow[row]=10*0.000022;//just to make debugging fast
      else//EZ
	Rgrow[row]=0.000104635;
    }
  
  //determine what to do when
  for(row=0;row<nrrows;row++)
    {
      H=CellHeight[row*14+nrcellsincurve];
      if(Pltavg[row]>=40)
	{
	  //all cells in zone type SCN
	}
      else if(Pltavg[row]>15)
	{
	  if(H<....)//grow
	    {
	    }
	  else//divide
	    {
	      nrrows+=1;//total nr of rows has increased
	      row+;//to not immediately let new cells grow
	    }
	}
      else
	{
	  if(H<...)//elongate
	    {
	    }
	  //differentiate
	}
    }

}
