#include "Header.hh"
#include "dSFMT.h"

void StoreAndCompare(int time, int starttime)
{	
  int q,i,j;
  static int totcells_init=0;
  int first_time[totcells];
 
  for(q=totcells_init;q<totcells;q++)
       first_time[q]=0;
    
    

for(q=0;q<totcells;q++)
{
	 if(first_time[q]==0)
	   {
		  BaselineAuxine[q]=MeanCells[q];
		  DiffAuxine[q]=0;
		  TimeOfAuxineIncrease[q]=-100;
		  first_time[q]=1;
		  totcells_init = totcells;
	   }
	 else
		DiffAuxine[q]=(MeanCells[q]-BaselineAuxine[q]);

		   
		  if(TimeOfAuxineIncrease[q]<0)//has not increased before
			{
			  if(DiffAuxine[q]>0.1*BaselineAuxine[q]) // MeanCells[q])//>0.001)
				TimeOfAuxineIncrease[q]=((double)(time-starttime));
			}
		
 }    
   MakePNGFile(time,0);

   

}

void AuxinIncrease(int time)   //, int starttime)
{
  static int totcells_init=0;
  int first_time[totcells];
  int q,i,j;

 for(q=totcells_init;q<totcells;q++)
       first_time[q]=0;
  
      
       for(q=0;q<totcells;q++)
       {
			if(first_time[q]==0)
			{
			  BaseMeanCell[q]=MeanCells[q];		
			  TempAuxin[q]=0;
			  first_time[q]=1;
			  
			}	
		
		    else
			{
			  TempAuxin[q]=(MeanCells[q]-BaseMeanCell[q]);
			}
			totcells_init = totcells;
		}
       
     
    // for(i=0;i<n;i++)
       //for(j=0;j<m;j++)
       for(q=0;q<totcells;q++)
       {
	  if(TempAuxin[q]!=0)//has not increased before
	    {
			
	        IncrAuxin[q] = TempAuxin[q]/BaseMeanCell[q];
	        TempAuxin[q]=0;
	       
	    }
	  else
			IncrAuxin[q] = TempAuxin[q];
		}
		
    
     MakePNGFile(time,6);

     
 }


